import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import React, { Component } from 'react';
import MoleculeField from '@s-ui/react-molecule-field';
import MoleculeAutosuggest, { MoleculeAutosuggestStates } from '@s-ui/react-molecule-autosuggest';

var getErrorState = function getErrorState(_ref) {
  var successText = _ref.successText,
      errorText = _ref.errorText;
  if (successText) return false;
  if (errorText) return true;
};

var getState = function getState(_ref2) {
  var successText = _ref2.successText,
      errorState = _ref2.errorState,
      alertText = _ref2.alertText;
  if (successText) return MoleculeAutosuggestStates.SUCCESS;
  if (errorState) return MoleculeAutosuggestStates.ERROR;
  if (alertText) return MoleculeAutosuggestStates.ALERT;
};

var MoleculeAutosuggestField = /*#__PURE__*/function (_Component) {
  _inheritsLoose(MoleculeAutosuggestField, _Component);

  function MoleculeAutosuggestField() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.refAutosuggest = /*#__PURE__*/React.createRef();

    _this.handleClick = function () {
      var domAutosuggest = _this.refAutosuggest.current;
      if (domAutosuggest) domAutosuggest.focus();
    };

    return _this;
  }

  var _proto = MoleculeAutosuggestField.prototype;

  _proto.render = function render() {
    var refAutosuggest = this.refAutosuggest,
        handleClick = this.handleClick;

    var _this$props = this.props,
        label = _this$props.label,
        useContrastLabel = _this$props.useContrastLabel,
        id = _this$props.id,
        successText = _this$props.successText,
        errorText = _this$props.errorText,
        alertText = _this$props.alertText,
        helpText = _this$props.helpText,
        inline = _this$props.inline,
        children = _this$props.children,
        onChange = _this$props.onChange,
        props = _objectWithoutPropertiesLoose(_this$props, ["label", "useContrastLabel", "id", "successText", "errorText", "alertText", "helpText", "inline", "children", "onChange"]);

    var errorState = getErrorState({
      successText: successText,
      errorText: errorText
    });
    var autosuggestState = getState({
      successText: successText,
      errorState: errorState,
      alertText: alertText
    });
    return /*#__PURE__*/React.createElement(MoleculeField, {
      name: id,
      label: label,
      successText: successText,
      errorText: errorText,
      alertText: alertText,
      helpText: helpText,
      inline: inline,
      onClickLabel: handleClick,
      onChange: onChange,
      useContrastLabel: useContrastLabel
    }, /*#__PURE__*/React.createElement(MoleculeAutosuggest, Object.assign({
      id: id,
      refMoleculeAutosuggest: refAutosuggest,
      errorState: errorState,
      state: autosuggestState
    }, props), children));
  };

  return MoleculeAutosuggestField;
}(Component);

MoleculeAutosuggestField.displayName = 'MoleculeAutosuggestField';
export default MoleculeAutosuggestField;
export { MoleculeAutosuggestStates };